% This is a function to gather some basic statistics for a decision tree
% 
% Usage: treeStats = gatherTreeStats(dT)
%
% Inputs: 
%
%   dT - the decision tree to gather statistics on
%
% Outputs: 
%
%   treeStats - a structure with the following fields: 
%
%       nLeafs - the number of leaf nodes in the tree
%
%       nNodes - the total number of nodes in the tree
%
function treeStats = gatherTreeStats(dT)

if dT.isLeaf
    treeStats.nLeafs = 1; 
    treeStats.nNodes = 1; 
else
    child1Stats = gatherTreeStats(dT.child1); 
    child2Stats = gatherTreeStats(dT.child2); 
    
    treeStats.nLeafs = child1Stats.nLeafs + child2Stats.nLeafs; 
    treeStats.nNodes = 1 + child1Stats.nNodes + child2Stats.nNodes; 
end